Index: doc/theses/mike_brooks_MMath/programs/sharing-demo.cfa
===================================================================
--- doc/theses/mike_brooks_MMath/programs/sharing-demo.cfa	(revision e72fc60c45c40f15ed2eb81b8f581c866cf011dc)
+++ doc/theses/mike_brooks_MMath/programs/sharing-demo.cfa	(revision 5546f50bf35c5f4954710cc34931ca3a077bf641)
@@ -37,10 +37,10 @@
 	assert( s1 == "a+c" );
 	sout | xstr(S1s1) | "\t& " | s1 | "\t& " | s1a | "\t& " | s2 | "\t\\\\";
-      
+
 	#define S1As1 s1a[1] = '-'
 	S1As1;
 	assert( s1a == "a-c" );
 	sout | xstr(S1As1) | "\t& " | s1 | "\t& " | s1a | "\t& " | s2 | "\t\\\\";
-      
+
 	#define S2s1 s2 [1] = '|'
 	S2s1;
@@ -49,5 +49,5 @@
 	sout | "\\end{tabular}";
 	sout | "\\par\\noindent";
-      
+
 	sout | "Assignment of a value is just a modificiation."
 		   "\nThe aliasing relationship is established at construction and is unaffected by assignment of a value.";
@@ -61,10 +61,10 @@
 	assert( s1 == "qrs" );
 	sout | xstr(S1qrs) | "\t& " | s1 | "\t& " | s1a | "\t& " | s2 | "\t\\\\";
-    
+
 	#define S1Atuv s1a = "tuv"
 	S1Atuv;
 	assert( s1a == "tuv" );
 	sout | xstr(S1Atuv) | "\t& " | s1 | "\t& " | s1a | "\t& " | s2 | "\t\\\\";
-    
+
 	#define S2wxy s2  = "wxy"
 	S2wxy;
@@ -87,5 +87,5 @@
 	assert( s2 == "wxy" );
 	sout | xstr(S1S2) | "\t& " | s1 | "\t& " | s1a | "\t& " | s2 | "\t\\\\";
-    
+
 	#define S1aaa s1  = "aaa"
 	S1aaa;
@@ -94,5 +94,5 @@
 	assert( s2 == "wxy" );
 	sout | xstr(S1aaa) | "\t& " | s1 | "\t& " | s1a | "\t& " | s2 | "\t\\\\";
-    
+
 	#define S2S1 s2  = s1
 	S2S1;
@@ -101,5 +101,5 @@
 	assert( s2 == "aaa" );
 	sout | xstr(S2S1) | "\t& " | s1 | "\t& " | s1a | "\t& " | s2 | "\t\\\\";
-    
+
 	#define S2bbb s2  = "bbb"
 	S2bbb;
@@ -191,5 +191,5 @@
 	sout | "\t\t\t\t& @s1@\t& @s1_mid@\t& @s2@\t\\\\";
 	sout | "\t& " | s1 | "\t& " | s1_mid | "\t& " | s2 | "\t\\\\";
-    
+
 	#define D2_s1mid_ff s1_mid = "ff"
 	D2_s1mid_ff;
@@ -207,5 +207,5 @@
 	sout | "\\end{tabular}";
 	sout | "\\par\\noindent";
-    
+
     sout | "In the \\emph{ff} step, which is a positive example of flow across an aliasing relationship, the result is straightforward to accept because the flow direction is from contained (small) to containing (large).  The following rules for edits through aliasing substrings will guide how to flow in the opposite direction.";
 	sout | "\\par";
@@ -233,5 +233,5 @@
 	assert( s1_mid == "i" );
 	sout  | xstr(D2_s1mid_i)  | "\t& " | s1 | "\t& " | s1_mid | "\t\\\\";
-    
+
 	#define D2_s1mid_empty s1_mid = ""
 	D2_s1mid_empty;
@@ -247,5 +247,5 @@
 	sout | "\\end{tabular}";
 	sout | "\\par\\noindent";
-    
+
     sout | "Multiple portions can be aliased.  When there are several aliasing substrings at once, the text editor analogy becomes an online multi-user editor.  I should be able to edit a paragraph in one place (changing the document's length), without my edits affecting which letters are within a mouse-selection that you had made previously, somewhere else.";
 	sout | "\\par\\noindent";
@@ -279,5 +279,5 @@
 	sout | "\\begin{tabular}{llllll}";
 	sout | "\t\t\t\t& @s1@\t& @s1_bgn@\t& @s1_crs@\t& @s1_mid@\t& @s1_end@\t\\\\";
-    
+
 	#define D2_s1crs_s1 string s1_crs = s1(3, 2)`shareEdits
 	D2_s1crs_s1;
@@ -288,5 +288,5 @@
 	assert( s1_end == "d" );  
 	sout  | xstr(D2_s1crs_s1)  | "\t& " | s1 | "\t& " | s1_bgn | "\t& " | s1_crs | "\t& " | s1_mid | "\t& " | s1_end | "\t\\\\";
-    
+
 	#define D2_s1crs_ppp s1_crs = "+++"
 	D2_s1crs_ppp;
@@ -316,5 +316,5 @@
 
 	// "The extreme form of this shortening happens when a bystander alias is a proper substring of an edit.  The bystander becomes an empty substring."
-    
+
 	string all = "They said hello again";
 	string greet     = all(10,5)`shareEdits;
@@ -327,5 +327,5 @@
 	assert( greet_end == "o" );
       
-    
+
 	greet = "sup";
 	assert( all == "They said sup again" );
@@ -334,5 +334,5 @@
 	// assert( greet_end == "" );
       
-    
+
   
 
@@ -342,5 +342,5 @@
 
   
-    
+
 	greet_bgn = "what"; 
       
@@ -353,5 +353,5 @@
 	// assert( greet_end == "" );    ------ Should be so, but fails
       
-    
+
 	greet_end = "..."; 
       
@@ -365,5 +365,5 @@
 	assert( greet_end == "..." );
       
-    
+
   
 